
if (Sys.info()[['user']] == 'shiny'){
  Sys.setenv(RETICULATE_PYTHON = "/usr/bin/python3")
}
library(shiny);library(reticulate);library(crypto2);library(dplyr);library(geckor);library(coinmarketcapr);library(tidyr);library(anytime);library(RJSONIO);
#library(beepr);library(XRPython);library(forecastHybrid);library(dplyr);library(forecast);library(bsts);library(nnfor)

################   Shiny   ##################
#rm(list = ls())
#ev<-RPython()
#pythonAddToPath("C:/Users/SAM/AppData/Local/Programs/Python/Python310/Lib/site-packages/", package = "",evaluator = ev)
#pythonImport("NobitexAPI",evaluator=ev)
#pythonImport("cryptocompare",evaluator=ev)
#py_install(packages="Nobitex",pip=T)
#py_run_string("import Nobitex")
#py_module_available("Nobitex")
#py_run_string("from NobitexAPI import Nobitex")

ui.robotnob4<- navbarPage("Robot-Nobitex by Dr. M. Jabbari Nooghabi (BUY)",
                          tabPanel("Reading Priminarly Values",
                                   sidebarLayout(sidebarPanel(
                                     #				 textInput("user1","User:",""),
                                     #				 textInput("pass1","Password:",""),
                                     #                textInput("curr1","Currency for Balance:",""),
                                     #                numericInput("days1","Days for History:",5),
                                     #                uiOutput("currency_selects"),
                                     #                actionButton("goButton","Run Data",class="btn-success"),
                                     textInput("execution","execution:","limit"),
                                     textInput("curr2","curr2:","dot"),
                                     textInput("curr3","curr3:","usdt"),
                                     numericInput("rangebox","Range of Boxplot:",1.5),
                                     numericInput("wait.low","Minumum wait time:",200),
                                     numericInput("wait.up","Maximum wait time:",210)
                                   ),
                                   mainPanel(uiOutput("tb1"))        
                                   )),
                          tabPanel("Reading Secondary Values",
                                   sidebarLayout(sidebarPanel(
                                     textInput("symbol","Currency for Symbol:",'DOTUSDT'),
                                     numericInput("break.time","Break Time:",052200),
                                     numericInput("buy0","Minimum Level of Buy:",16.6),
                                     #numericInput("bb","Break:",1),
                                     submitButton("Run Model",icon("sync")),
                                     #actionButton("goButton","STOP!",class="btn-success"),
                                     numericInput("percentbuy","Percent of Buy:",0.02),
                                     numericInput("percentsell","Percent of Sell:",0.02),
                                     numericInput("amountbuy","Amount of Buy:",1),
                                     numericInput("amountsell","Amount of Sell:",1),
                                     numericInput("h","h (Amount plus or minus):",0.001)
                                   ),
                                   mainPanel(helpText("The Results"),
                                             verbatimTextOutput("out"),
                                             verbatimTextOutput("out1"),
                                             #verbatimTextOutput("out1")
                                   ))
                          ))

server.robotnob4<- function(input,output){
  output$out <- renderPrint({
    
print("################################################################")
#    rm(list = ls())
    #py_install(packages="Nobitex",pip=T)
    py_run_string("import Nobitex")
    py_module_available("Nobitex")
    py_run_string("from NobitexAPI import Nobitex")
    py$user1='jabbarinm@um.ac.ir';py$pass1='Nooghab_30'
    py_run_string("nt=Nobitex(user1,pass1)")
    print(py$nt)
print("################################################################")
  })
#  output$out1 <- renderPrint({
#    py$symbol=input$symbol;py$execution=input$execution;py$src_curr=input$curr2;py$curr2=input$curr2;py$curr3=input$curr3;py$h=input$h
#    i=j=1;buy=sell=bal1=bal2=py$idbuy=py$idsell=systime=criticalbuy=criticalsell=c();sell[1]=input$buy0/(1-input$percentbuy);buyconfirm=sellconfirm=1
#    while(as.numeric(format(Sys.time(),"%d%H%M"))<input$break.time){
#      #ordask=ordbids=matrix();ordask[1,1]=runif(1,27,29);ordbids[1,1]=runif(1,ordask[1,1]+0.1,29)
#      print(c("i=",i,"Critical Buy",criticalbuy,"Minimum Value of Buy 0",input$buy0));print(c("j=",j,"Critical Sell",criticalsell))
#      print("###############################################")
#      if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
#      #Sys.sleep(round(runif(1,input$wait.low,input$wait.up)))
#      py_run_string("order_book1=nt.order_book(symbol=symbol)");#print(py$order_book1)
#      (ordask=matrix(as.numeric(unlist(py$order_book1$asks)),nc=2,byrow=T));(ordbids=matrix(as.numeric(unlist(py$order_book1$bids)),nc=2,byrow=T))
#      if(any(ordask[,2]%in%boxplot(ordask[,2],range=input$rangebox,plot=F)$out))ordaskout<-matrix(ordask[ordask[,2]%in%boxplot(ordask[,2],range=input$rangebox,plot=F)$out,],nc=2);if(any(ordbids[,2]%in%boxplot(ordbids[,2],range=input$rangebox,plot=F)$out))ordbidsout<-matrix(ordbids[ordbids[,2]%in%boxplot(ordbids[,2],range=input$rangebox,plot=F)$out,],nc=2)
#      print(rep("*",19));print(c("ordask[1,1]",ordask[1,1],"ordbids[1,1]",ordbids[1,1],"Diff",abs(ordbids[1,1]-ordask[1,1])/ordask[1,1]))
#      print(rep("*",19));print(rbind(c("ordask-rank","ordaskout-price","ordaskout-amount"),cbind(which(ordask[,2]%in%ordaskout),ordaskout)));if(!is.null(ordaskout)&!is.null(ordbidsout))print(c("Diff Out",abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]))
#      print(rep("$",19));print(rbind(c("ordbids-rank","ordbidsout-price","ordbidsout-amount"),cbind(which(ordbids[,2]%in%ordbidsout),ordbidsout)));if(!is.null(ordaskout)&!is.null(ordbidsout))print(c("Diff Out",abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]))
#      py_run_string("bal2=nt.balance(currency=curr3)");
#      bal2=as.numeric(py$bal2$balance);print(c("Balance,",input$curr3,bal2))
#      py_run_string("bal1=nt.balance(currency=curr2)")
#      bal1=as.numeric(py$bal1$balance);print(c("Balance,",input$curr2,bal1));;print(rep("*",19))
#      if(i<=j&dim(ordaskout)[1]>=dim(ordbidsout)[1])if(ordask[1,1]<=(1-input$percentbuy)*sell[j]){
#        py$pricebuy=ordask[1,1]+input$h
#        if(as.numeric(py$bal2$balance)>input$amountbuy*1.011*ordask[1,1]){
#          py_run_string("add_order_buy=nt.add_order(type='buy',execution=execution,src_currency=curr2,dst_currency=curr3,amount=amountbuy,price=pricebuy)");
#          print(c("Status of Buy",py$add_order_buy$status))
#          if(py$add_order_buy$status=='ok'){
#            buy<-c(buy,py$pricebuy);print(c("OK Order of Buy",i,buy[i],"Time=",format(Sys.time(),"%d%m%y-%H%M")));print(rep("*",19))
#          }}}
#      py$idbuy=py$add_order_buy$order$id;py_run_string("order_status=nt.order_status(id=idbuy)")
#      if(py$order_status$order$status=='Done'){
#        print("OK Buy Confirmed");i=i+1;print(rep("*",19))}
#      if(j<i)if(ordbids[1,1]>=(1+input$percentsell)*buy[i-1]){
#        py$pricesell=ordbids[1,1]-input$h
#        if(as.numeric(py$bal1$balance)>input$amountsell*1.011){
#          py_run_string("add_order_sell=nt.add_order(type='sell',execution=execution,src_currency=curr2,dst_currency=curr3,amount=amountsell,price=pricesell)");
#          print(c("Status of Sell",py$add_order_sell$status))
#          if(py$add_order_sell$status=='ok'){
#            sell<-c(sell,py$pricesell);print(c("OK Sell",j+1,sell[j+1],"Time=",format(Sys.time(),"%d%m%y-%H%M")));print(rep("*",19))
#          }}}
#      py$idsell=py$add_order_sell$order$id;py_run_string("order_status=nt.order_status(id=idsell)");
#      if(py$order_status$order$status=='Done'){
#        print("OK Sell Confirmed");j=j+1;print(rep("*",19))}
#      if(j>=2){print(rep("#",19));print(c("Interest(%)=",abs(sell[j]-buy[i-1])/buy[i-1]*100));print(rep("#",19))}
#      if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
#      Sys.sleep(round(runif(1,input$wait.low,input$wait.up)))
#    }
#    print(rbind(buy,sell))
#  })
}

shinyApp(ui.robotnob4,server.robotnob4)

